#include "stdafx.h"
#include <windows.h>
#include "BasicLib.h"

VOID StringToLower(IN char *String,OUT char *OutString)
{
	int i;
	//printf("stringlen = %d\n",strlen(String));
	for(i = 0; i < strlen(String); i++)
	{
		if((String[i] >= 'A') && (String[i] <= 'Z'))
			OutString[i] = String[i] + 0x20;
		else OutString[i] = String[i];
		//printf("%c",OutString[i]);
	}
	OutString[i] = '\0';
}

VOID UnicodeStringToString(IN BYTE *UnicodeInputData, OUT char *String)
{
	for(int i = 0; i < UnicodeInputData[0]; i++)
	{
		(char)*(String + i) = UnicodeInputData[2 + i * sizeof(wchar_t)];
		//printf("%c",String[i]);
	}
	//printf("\n");
}

VOID StringToUnicodeStringWithOffset(IN char *String, IN BYTE InputDataOffset, OUT BYTE *UnicodeInputData)
{
	BYTE StringSize = 0, MaxStringSize = 0;

	StringSize = (BYTE) (strlen(String) * sizeof(char));
	//printf("wcslen(String) = %d, StringSize = %d\n",wcslen(String),StringSize);

	UnicodeInputData[InputDataOffset] = StringSize;
	UnicodeInputData[InputDataOffset + 1] = MaxStringSize;

	for(int i = 0; i < StringSize; i++)
	{
		UnicodeInputData[InputDataOffset + 2 + i * sizeof(char)] = (char)*(String + i);
		//printf("UnicodeInputData->InputData[%d] = %02x\n",InputDataOffset + i + 2,UnicodeInputData[InputDataOffset + 2 + i]);
	}
}

VOID StringToHexByteWithOffset(IN char *String, IN BYTE ConvertStart, OUT BYTE *HexData)
{
	BYTE StringSize = 0, MaxStringSize = 2;
	int Index = 0, HexIndex = ConvertStart;
	char StringTemp[4];


	StringSize = strlen(String);
	//printf("wcslen(String) = %d, StringSize = %d\n",wcslen(String),StringSize);
	if (StringSize > 4)
	{
		printf("  Error. Parameter must in [0 - FFFF] \n");
	}
	else 
	{
		for ( Index = 0; Index < 4 - StringSize; Index ++ )
		{

			StringTemp[Index] = '0';
		}
		for ( ; Index < 4 ; Index ++ )
		{

			StringTemp[Index] = String[Index - (4 - StringSize)];
		}
	}

	for ( Index = 3; Index >= 0; Index = Index - 2 )
	{
		
	   HexData[HexIndex] = (StringTemp[Index] - '0' ) + ( StringTemp[Index - 1] - '0') * 16; //Just for BYTE	   
	   //printf("HexData[%d] = %02x\n",HexIndex,HexData[HexIndex]);
	   HexIndex ++;
	}
}

VOID StringConvert(IN char StringBuff[][0x70], IN INPUT_BUFF_FORMAT InputFormat, OUT BYTE *ConvertData)
{
  BYTE    Index = 0, IndexHead = 0, IndexTail = 0;
  for (BYTE Count = 0; Count < InputFormat.DataCount ; Count++)
  {
	  if(InputFormat.FormatBuff[Count] == UnicodeString)
	  {
		 IndexTail = strlen(StringBuff[Count]); //IndexHead + IndexTail + UnicodeStringOffset
		 StringToUnicodeStringWithOffset(StringBuff[Count], IndexHead, ConvertData);
		 IndexHead = IndexHead + IndexTail*sizeof(char) + UnicodeStringOffset;
	  }
	  else if(InputFormat.FormatBuff[Count] == WordHex)
	  {
		 StringToHexByteWithOffset(StringBuff[Count], IndexHead, ConvertData);
		 IndexHead = IndexHead + 2;
		 IndexTail = IndexHead;
	  }
  }
}