#include "stdafx.h"
#include <windows.h>
#include "ACPITable.h"

UINT32 GetACPITable()
{
  DWORD ACPIAddrOffset = 0;
  
  ACPIAddrOffset = MapMem_wcsrch( ACPIBASE, 0x20000, "RSD PTR" );

  if( ACPIAddrOffset != -1 )
  {
			//printf("GetACPITable %x\n", ACPIAddrOffset + ACPIBASE);
			return (ACPIAddrOffset + ACPIBASE);
  }
  else   printf("NotFound pRSDTPhys\n");

}

UINT32 GetRSDTTable(UINT32 ACPITableAddr)
{
  RSDT_PTR    RSDT;
  PDWORD      pTemp;
  DWORD       Temp;

  pTemp = (&Temp);
  Read_Mem_Dword(ACPITableAddr + Cal_OFFSET(RSDT,address),pTemp);
 // printf("GetRSDTTable %08x\n", *pTemp);

  return *pTemp;
}

UINT32 GetFACPTable(UINT32 RSDTTableAddr)
{
  RSDT_Table  RSDT;
  PDWORD      pTemp;
  DWORD       Temp;

  pTemp = (&Temp);
  Read_Mem_Dword(RSDTTableAddr + Cal_OFFSET(RSDT,entry[0]),pTemp);
  //printf("GetFACPTable %08x\n", *pTemp);

  return *pTemp;
}

UINT32 GetDSDTTable(UINT32 FACPTableAddr)
{
   FACP_Table  FACP;
   PDWORD      pTemp;
   DWORD       Temp;

   pTemp = (&Temp);
   Read_Mem_Dword(FACPTableAddr + Cal_OFFSET(FACP,DSDT),pTemp);
   
   //printf("GetDSDTTable %x\n", *pTemp);
   return *pTemp;
}
