#define     Cal_OFFSET(struc,member) (char *)&struc.member-(char *)&struc
#define     UnicodeStringOffset 2
//#define InDataCount 2
//#define OutDataCount 1

typedef struct _LSA_UNICODE_STRING{
        UINT8  Length;
		UINT8  MaximumLength;
		UINT16 Buffer[1];
}UNICODE_STRING;


enum FORMATLIST
{
	UnicodeString,
	HexUint8 = 1,  //1 bytes
	HexUint16 = 2, //2 bytes
	HexUint32 = 4, //4 bytes
	HexUint64 = 8, //8 bytes
	Undefined
};
typedef struct _INPUT_BUFF_FORMAT{
	    int   DataCount;
        FORMATLIST *FormatBuff;
 }INPUT_BUFF_FORMAT;

typedef struct _OUTPUT_BUFF_FORMAT{
	    int   DataCount;
        FORMATLIST *FormatBuff;
 }OUTPUT_BUFF_FORMAT;



VOID StringToLower(IN char *String,OUT char *OutString);

VOID UnicodeStringToString(IN BYTE *UnicodeInputData, OUT char *String);
VOID StringToUnicodeStringWithOffset(IN char *String, IN BYTE InputDataOffset, OUT BYTE *UnicodeInputData);
int StringToHexByteWithOffset(IN FORMATLIST HexFormat,IN char *String, IN BYTE ConvertStart, OUT BYTE *HexData);

int StringConvert(IN char StringBuff[][0x70], IN INPUT_BUFF_FORMAT InputFormat, OUT BYTE *ConvertData);

